*** a/src/backend/storage/ipc/procarray.c
--- b/src/backend/storage/ipc/procarray.c
***************
*** 101,106 **** static ProcArrayStruct *procArray;
--- 101,109 ----
  static PGPROC *allProcs;
  static PGXACT *allPgXact;
  
+ static PGAutonomousXACT *allPgAutonomousXact;
+ 
+ 
  /*
   * Bookkeeping for tracking emulated transactions in recovery
   */
***************
*** 246,251 **** CreateSharedProcArray(void)
--- 249,255 ----
  
  	allProcs = ProcGlobal->allProcs;
  	allPgXact = ProcGlobal->allPgXact;
+ 	allPgAutonomousXact = ProcGlobal->allPgAutonomousXact;
  
  	/* Create or attach to the KnownAssignedXids arrays too, if needed */
  	if (EnableHotStandby)
***************
*** 443,448 **** ProcArrayEndTransaction(PGPROC *proc, TransactionId latestXid)
--- 447,501 ----
  	}
  }
  
+ void
+ ProcArrayEndAutonomousTransaction(PGPROC *proc, TransactionId latestXid)
+ {
+ 	PGAutonomousXACT *pgautonouxact = GetCurrentPGAutonomousXACT();
+ 	if (TransactionIdIsValid(latestXid))
+ 	{
+ 		/*
+ 		 * We must lock ProcArrayLock while clearing our advertised XID, so
+ 		 * that we do not exit the set of "running" transactions while someone
+ 		 * else is taking a snapshot.  See discussion in
+ 		 * src/backend/access/transam/README.
+ 		 */
+ 
+ 
+ 		LWLockAcquire(ProcArrayLock, LW_EXCLUSIVE);
+ 
+ 		pgautonouxact->xid = InvalidTransactionId;
+ 		pgautonouxact->xmin = InvalidTransactionId;
+ 		/* must be cleared with xid/xmin: */
+ 		pgautonouxact->delayChkpt = false;		/* be sure this is cleared in abort */
+ 
+ 		/* Clear the subtransaction-XID cache too while holding the lock */
+ 		pgautonouxact->nxids = 0;
+ 		pgautonouxact->overflowed = false;
+ 
+ 		/* Also advance global latestCompletedXid while holding the lock */
+ 		if (TransactionIdPrecedes(ShmemVariableCache->latestCompletedXid,
+ 								  latestXid))
+ 			ShmemVariableCache->latestCompletedXid = latestXid;
+ 
+ 		LWLockRelease(ProcArrayLock);
+ 	}
+ 	else
+ 	{
+ 		/*
+ 		 * If we have no XID, we don't need to lock, since we won't affect
+ 		 * anyone else's calculation of a snapshot.  We might change their
+ 		 * estimate of global xmin, but that's OK.
+ 		 */
+ 		Assert(!TransactionIdIsValid(allPgAutonomousXact[proc->pgprocno].xid));
+ 		pgautonouxact->xmin = InvalidTransactionId;
+ 		/* must be cleared with xid/xmin: */
+ 		pgautonouxact->delayChkpt = false;
+ 		/* be sure this is cleared in abort */
+ 
+ 		Assert(pgautonouxact->nxids == 0);
+ 		Assert(pgautonouxact->overflowed == false);
+ 	}
+ }
  
  /*
   * ProcArrayClearTransaction -- clear the transaction fields
***************
*** 854,860 **** TransactionIdIsInProgress(TransactionId xid)
  	ProcArrayStruct *arrayP = procArray;
  	TransactionId topxid;
  	int			i,
! 				j;
  
  	/*
  	 * Don't bother checking a transaction older than RecentXmin; it could not
--- 907,914 ----
  	ProcArrayStruct *arrayP = procArray;
  	TransactionId topxid;
  	int			i,
! 				j,
! 				k;
  
  	/*
  	 * Don't bother checking a transaction older than RecentXmin; it could not
***************
*** 926,937 **** TransactionIdIsInProgress(TransactionId xid)
  	for (i = 0; i < arrayP->numProcs; i++)
  	{
  		int			pgprocno = arrayP->pgprocnos[i];
  		volatile PGPROC *proc = &allProcs[pgprocno];
  		volatile PGXACT *pgxact = &allPgXact[pgprocno];
  		TransactionId pxid;
  
  		/* Ignore my own proc --- dealt with it above */
! 		if (proc == MyProc)
  			continue;
  
  		/* Fetch xid just once - see GetNewTransactionId */
--- 980,994 ----
  	for (i = 0; i < arrayP->numProcs; i++)
  	{
  		int			pgprocno = arrayP->pgprocnos[i];
+ 		int			pgautoxno = pgprocno * MAX_AUTOX_NESTING_LEVEL;
  		volatile PGPROC *proc = &allProcs[pgprocno];
  		volatile PGXACT *pgxact = &allPgXact[pgprocno];
+ 		volatile PGAutonomousXACT *pgautonomousxact = &allPgAutonomousXact[pgautoxno];
  		TransactionId pxid;
+ 		TransactionId pautoxid = InvalidTransactionId;
  
  		/* Ignore my own proc --- dealt with it above */
! 		if (proc == MyProc && !MyProc->inAutoTXLevel)
  			continue;
  
  		/* Fetch xid just once - see GetNewTransactionId */
***************
*** 982,987 **** TransactionIdIsInProgress(TransactionId xid)
--- 1039,1083 ----
  		 */
  		if (pgxact->overflowed)
  			xids[nxids++] = pxid;
+ 
+ 		/*
+ 		 * check autonomous transaction
+ 		 */
+ 		for (j = 0; j < proc->inAutoTXLevel; j++)
+ 		{
+ 			/*check top level autoTX*/
+ 			pautoxid = pgautonomousxact[j].xid;
+ 			if (!TransactionIdIsValid(pautoxid))
+ 				break;
+ 
+ 			if (TransactionIdEquals(pautoxid, xid))
+ 			{
+ 				LWLockRelease(ProcArrayLock);
+ 				xc_by_main_xid_inc();
+ 				return true;
+ 			}
+ 
+ 			/*if the xid logically < pautoxid, we don't need check lower TX*/
+ 			if (TransactionIdPrecedes(xid, pautoxid))
+ 				break;
+ 
+ 			/*check sub transactions of this autoTX*/
+ 			for (k = pgautonomousxact[j].nxids - 1; k >= 0; k--)
+ 			{
+ 				/* Fetch xid just once - see GetNewTransactionId */
+ 				TransactionId cxid = pgautonomousxact[j].subxids.xids[k];
+ 
+ 				if (TransactionIdEquals(cxid, xid))
+ 				{
+ 					LWLockRelease(ProcArrayLock);
+ 					xc_by_child_xid_inc();
+ 					return true;
+ 				}
+ 			}
+ 
+ 			if (pgautonomousxact[j].overflowed)
+ 				xids[nxids++] = pautoxid;
+ 		}
  	}
  
  	/*
***************
*** 1367,1372 **** GetSnapshotData(Snapshot snapshot)
--- 1463,1469 ----
  	bool		suboverflowed = false;
  	volatile TransactionId replication_slot_xmin = InvalidTransactionId;
  	volatile TransactionId replication_slot_catalog_xmin = InvalidTransactionId;
+ 	int         autoTxIndex = 0;
  
  	Assert(snapshot != NULL);
  
***************
*** 1435,1440 **** GetSnapshotData(Snapshot snapshot)
--- 1532,1542 ----
  			volatile PGXACT *pgxact = &allPgXact[pgprocno];
  			TransactionId xid;
  
+ 			int			pgautoxno = pgprocno * MAX_AUTOX_NESTING_LEVEL;
+ 			volatile PGPROC *pgproc = &allProcs[pgprocno];
+ 			volatile PGAutonomousXACT *pgAutonomousxact =
+ 												&allPgAutonomousXact[pgautoxno];
+ 
  			/*
  			 * Backend is doing logical decoding which manages xmin
  			 * separately, check below.
***************
*** 1471,1477 **** GetSnapshotData(Snapshot snapshot)
  			 */
  			if (NormalTransactionIdPrecedes(xid, xmin))
  				xmin = xid;
! 			if (pgxact == MyPgXact)
  				continue;
  
  			/* Add XID to snapshot. */
--- 1573,1585 ----
  			 */
  			if (NormalTransactionIdPrecedes(xid, xmin))
  				xmin = xid;
! 
! 			/*
! 			 * When pgAutonomousxact->inAutoTX is true, there is a autonomous
! 			 * transaction in this proc, it still need add the main transaction
! 			 * to the snapshot.
!   			 */
! 			if (pgxact == MyPgXact && !MyProc->inAutoTXLevel)
  				continue;
  
  			/* Add XID to snapshot. */
***************
*** 1511,1516 **** GetSnapshotData(Snapshot snapshot)
--- 1619,1664 ----
  					}
  				}
  			}
+ 
+ 			/* Add auto tx to snapshot */
+ 			for (autoTxIndex = 0; autoTxIndex < pgproc->inAutoTXLevel; autoTxIndex++)
+ 			{
+ 				xid = pgAutonomousxact[autoTxIndex].xid;
+ 
+ 				/* If auto tx is myself, skip it */
+ 				if (&pgAutonomousxact[autoTxIndex] == &MyPgAutonomousXact[MyProc->inAutoTXLevel - 1])
+ 					break;
+ 
+ 				/*
+ 				 * If the auto tx has no XID assigned, we can skip it; it
+ 				 * won't have sub-XIDs either.  If the XID is >= xmax, we can also
+ 				 * skip it; such tx will be treated as running anyway
+ 				 * (and any sub-XIDs will also be >= xmax).
+ 				 */
+ 				if (!TransactionIdIsNormal(xid)
+ 					|| !NormalTransactionIdPrecedes(xid, xmax))
+ 					break;
+ 
+ 				snapshot->xip[count++] = xid;
+ 
+ 				if (!suboverflowed)
+ 				{
+ 					if (pgAutonomousxact[autoTxIndex].overflowed)
+ 						suboverflowed = true;
+ 					else
+ 					{
+ 						int	nxids = pgAutonomousxact[autoTxIndex].nxids;
+ 
+ 						if (nxids > 0)
+ 						{
+ 							memcpy(snapshot->subxip + subcount,
+ 									(void *) pgAutonomousxact[autoTxIndex].subxids.xids,
+ 							   		nxids * sizeof(TransactionId));
+ 							subcount += nxids;
+ 						}
+ 					}
+ 				}
+ 			}
  		}
  	}
  	else
***************
*** 2042,2047 **** GetVirtualXIDsDelayingChkpt(int *nvxids)
--- 2190,2198 ----
  		int			pgprocno = arrayP->pgprocnos[index];
  		volatile PGPROC *proc = &allProcs[pgprocno];
  		volatile PGXACT *pgxact = &allPgXact[pgprocno];
+ 		int pgautotxno = pgprocno*MAX_AUTOX_NESTING_LEVEL;
+ 		volatile PGAutonomousXACT *pgautonomousxact = &allPgAutonomousXact[pgautotxno];
+ 
  
  		if (pgxact->delayChkpt)
  		{
***************
*** 2795,2800 **** XidCacheRemoveRunningXids(TransactionId xid,
--- 2946,3031 ----
  	LWLockRelease(ProcArrayLock);
  }
  
+ /*
+  * XidCacheRemoveAutoRunningXids
+  *
+  * Remove a bunch of TransactionIds from the list of known-running
+  * subtransactions of auto transaction for my backend.	Both the specified xid and those in
+  * the xids[] array (of length nxids) are removed from the subxids cache.
+  * latestXid must be the latest XID among the group.
+  */
+ void
+ XidCacheRemoveAutoRunningXids(TransactionId xid,
+ 						  int nxids, const TransactionId *xids,
+ 						  TransactionId latestXid, bool isTopAutoTX)
+ {
+ 	int			i,
+ 				j;
+ 	PGAutonomousXACT * currentautox = GetCurrentPGAutonomousXACT();
+ 	Assert(TransactionIdIsValid(xid));
+ 
+ 	/*
+ 	 * Under normal circumstances xid and xids[] will be in increasing order,
+ 	 * as will be the entries in subxids.  Scan backwards to avoid O(N^2)
+ 	 * behavior when removing a lot of xids.
+ 	 */
+ 	for (i = nxids - 1; i >= 0; i--)
+ 	{
+ 		TransactionId anxid = xids[i];
+ 
+ 		for (j = currentautox->nxids - 1; j >= 0; j--)
+ 		{
+ 			if (TransactionIdEquals(currentautox->subxids.xids[j], anxid))
+ 			{
+ 				currentautox->subxids.xids[j] = currentautox->subxids.xids[currentautox->nxids - 1];
+ 				currentautox->nxids--;
+ 				break;
+ 			}
+ 
+ 		}
+ 		/*
+ 		 * Ordinarily we should have found it, unless the cache has
+ 		 * overflowed. However it's also possible for this routine to be
+ 		 * invoked multiple times for the same subtransaction, in case of an
+ 		 * error during AbortSubTransaction.  So instead of Assert, emit a
+ 		 * debug warning.
+ 		 */
+ 		if (j < 0 && !currentautox->overflowed)
+ 			ereport(WARNING,
+ 					(errmsg("did not find subXID %u in MyPgAutonomousXact",
+ 						anxid)));
+ 
+ 	}
+ 
+ 	/* top level in auto TX, PopTransaction will MemSet MyPgAutonomousXact */
+ 	if(!isTopAutoTX)
+ 	{
+ 		for (j = currentautox->nxids - 1; j >= 0; j--)
+ 		{
+ 			if (TransactionIdEquals(currentautox->subxids.xids[j], xid))
+ 			{
+ 				currentautox->subxids.xids[j] = currentautox->subxids.xids[currentautox->nxids - 1];
+ 				currentautox->nxids--; ;
+ 				break;
+ 			}
+ 		}
+ 		/* Ordinarily we should have found it, unless the cache has overflowed */
+ 		if (j < 0 && !currentautox->overflowed)
+ 			ereport(WARNING,
+ 					(errmsg("did not find subXID %u in MyPgAutonomousXact",
+ 						xid)));
+ 	}
+ 
+ 	LWLockAcquire(ProcArrayLock, LW_EXCLUSIVE);
+ 
+ 	/* Also advance global latestCompletedXid while holding the lock */
+ 	if (TransactionIdPrecedes(ShmemVariableCache->latestCompletedXid,
+ 							  latestXid))
+ 		ShmemVariableCache->latestCompletedXid = latestXid;
+ 
+ 	LWLockRelease(ProcArrayLock);
+ }
+ 
  #ifdef XIDCACHE_DEBUG
  
  /*
*** a/src/backend/storage/lmgr/lmgr.c
--- b/src/backend/storage/lmgr/lmgr.c
***************
*** 23,29 ****
  #include "storage/lmgr.h"
  #include "storage/procarray.h"
  #include "utils/inval.h"
! 
  
  /*
   * Struct to hold context info for transaction lock waits.
--- 23,29 ----
  #include "storage/lmgr.h"
  #include "storage/procarray.h"
  #include "utils/inval.h"
! #include "storage/proc.h"
  
  /*
   * Struct to hold context info for transaction lock waits.
***************
*** 524,529 **** XactLockTableWait(TransactionId xid, Relation rel, ItemPointer ctid,
--- 524,534 ----
  		error_context_stack = &callback;
  	}
  
+ #ifdef USE_ASSERT_CHECKING
+ 		if(!MyProc->inAutoTXLevel)
+ 			Assert(!TransactionIdEquals(xid, GetTopTransactionIdIfAny()));
+ #endif
+ 
  	for (;;)
  	{
  		Assert(TransactionIdIsValid(xid));
*** a/src/backend/storage/lmgr/lock.c
--- b/src/backend/storage/lmgr/lock.c
***************
*** 355,360 **** static void LockRefindAndRelease(LockMethod lockMethodTable, PGPROC *proc,
--- 355,363 ----
  					 LOCKTAG *locktag, LOCKMODE lockmode,
  					 bool decrement_strong_lock_count);
  
+ static void InternalDeadLockCheckforAutoX(LockMethod lockMethodTable,
+ 											LOCKMODE lockmode,
+ 											LOCK *lock, PROCLOCK *proclock);
  
  /*
   * InitLocks -- Initialize the lock manager's data structures.
***************
*** 783,788 **** LockAcquireExtended(const LOCKTAG *locktag,
--- 786,797 ----
  	 */
  	if (locallock->nLocks > 0)
  	{
+ 		if(MyProc->inAutoTXLevel && locallock->proclock != NULL)
+ 		{
+ 			InternalDeadLockCheckforAutoX(lockMethodTable, lockmode, locallock->lock, locallock->proclock);
+ 		}
+ 
+ 
  		GrantLockLocal(locallock, owner);
  		return LOCKACQUIRE_ALREADY_HELD;
  	}
***************
*** 818,825 **** LockAcquireExtended(const LOCKTAG *locktag,
  	 * lock type on a relation we have already locked using the fast-path, but
  	 * for now we don't worry about that case either.
  	 */
! 	if (EligibleForRelationFastPath(locktag, lockmode) &&
! 		FastPathLocalUseCount < FP_LOCK_SLOTS_PER_BACKEND)
  	{
  		uint32		fasthashcode = FastPathStrongLockHashPartition(hashcode);
  		bool		acquired;
--- 827,835 ----
  	 * lock type on a relation we have already locked using the fast-path, but
  	 * for now we don't worry about that case either.
  	 */
! 	if (EligibleForRelationFastPath(locktag, lockmode)
! 		&& FastPathLocalUseCount < FP_LOCK_SLOTS_PER_BACKEND
! 		&& !MyProc->inAutoTXLevel)
  	{
  		uint32		fasthashcode = FastPathStrongLockHashPartition(hashcode);
  		bool		acquired;
***************
*** 1142,1147 **** SetupLockInTable(LockMethod lockMethodTable, PGPROC *proc,
--- 1152,1160 ----
  		uint32		partition = LockHashPartition(hashcode);
  
  		proclock->holdMask = 0;
+ 		MemSet(proclock->holdMaskByAutoTX, 0, MAX_AUTOX_NESTING_LEVEL * (sizeof(LOCKMASK)));
+ 
+ 		proclock->holdMaskByNormalTX = 0;
  		proclock->releaseMask = 0;
  		/* Add proclock to appropriate lists */
  		SHMQueueInsertBefore(&lock->procLocks, &proclock->lockLink);
***************
*** 1272,1277 **** LockCheckConflicts(LockMethod lockMethodTable,
--- 1285,1292 ----
  	LOCKMASK	myLocks;
  	LOCKMASK	otherLocks;
  	int			i;
+ 	LOCKMASK	myLocksByAutoTX;
+ 
  
  	/*
  	 * first check for global conflicts: If no locks conflict with my request,
***************
*** 1295,1300 **** LockCheckConflicts(LockMethod lockMethodTable,
--- 1310,1326 ----
  	 */
  	myLocks = proclock->holdMask;
  	otherLocks = 0;
+ 
+ 	/* In autonomous TX, check whether lock conflict with parent TX */
+ 	if(MyProc->inAutoTXLevel)
+ 	{
+ 		myLocksByAutoTX = proclock->holdMaskByAutoTX[MyProc->inAutoTXLevel - 1];
+ 		/* if conflict with parent TX, It's a dead lock */
+ 		InternalDeadLockCheckforAutoX(lockMethodTable, lockmode, lock, proclock);
+ 		/* Something conflicts.	But it could still be autonomous own lock. */
+ 		myLocks = myLocksByAutoTX;
+ 	}
+ 
  	for (i = 1; i <= numLockModes; i++)
  	{
  		int			myHolding = (myLocks & LOCKBIT_ON(i)) ? 1 : 0;
***************
*** 1333,1344 **** LockCheckConflicts(LockMethod lockMethodTable,
--- 1359,1393 ----
  void
  GrantLock(LOCK *lock, PROCLOCK *proclock, LOCKMODE lockmode)
  {
+ 	uint8 autoTXLevel;
+ 
  	lock->nGranted++;
  	lock->granted[lockmode]++;
  	lock->grantMask |= LOCKBIT_ON(lockmode);
  	if (lock->granted[lockmode] == lock->requested[lockmode])
  		lock->waitMask &= LOCKBIT_OFF(lockmode);
  	proclock->holdMask |= LOCKBIT_ON(lockmode);
+ 
+ 
+ 	if (MyProc == proclock->tag.myProc)
+ 	{
+ 		autoTXLevel = GetCurrentResourceOwnerAutoTXLevel();
+ 	}
+ 	else
+ 	{
+ 		autoTXLevel = proclock->tag.myProc->inAutoTXLevel;
+ 	}
+ 
+ 	proclock->holdMask |= LOCKBIT_ON(lockmode);
+ 	if (autoTXLevel)
+ 	{
+ 		proclock->holdMaskByAutoTX[autoTXLevel - 1] |= LOCKBIT_ON(lockmode);
+ 	}
+ 	else
+ 	{
+ 		proclock->holdMaskByNormalTX |= LOCKBIT_ON(lockmode);
+ 	}
+ 
  	LOCK_PRINT("GrantLock", lock, lockmode);
  	Assert((lock->nGranted > 0) && (lock->granted[lockmode] > 0));
  	Assert(lock->nGranted <= lock->nRequested);
***************
*** 1394,1399 **** UnGrantLock(LOCK *lock, LOCKMODE lockmode,
--- 1443,1457 ----
  	/*
  	 * Now fix the per-proclock state.
  	 */
+ 	if (MyProc->inAutoTXLevel)
+ 	{
+ 		proclock->holdMaskByAutoTX[MyProc->inAutoTXLevel - 1] &= LOCKBIT_OFF(lockmode);
+ 	}
+ 	else
+ 	{
+ 		proclock->holdMaskByNormalTX &= LOCKBIT_OFF(lockmode);
+ 
+ 	}
  	proclock->holdMask &= LOCKBIT_OFF(lockmode);
  	PROCLOCK_PRINT("UnGrantLock: updated", proclock);
  
***************
*** 4084,4086 **** VirtualXactLock(VirtualTransactionId vxid, bool wait)
--- 4142,4185 ----
  	LockRelease(&tag, ShareLock, false);
  	return true;
  }
+ 
+ static void
+ InternalDeadLockCheckforAutoX(LockMethod lockMethodTable, LOCKMODE lockmode,
+ 										  LOCK *lock, PROCLOCK *proclock)
+ {
+ 	int i = 0;
+ 	/*check deadlock with main xact*/
+ 	if (lockMethodTable->conflictTab[lockmode] & proclock->holdMaskByNormalTX)
+ 	{
+ 		lock->nRequested--;
+ 		Assert(lock->requested[lockmode] > 0);
+ 		lock->requested[lockmode]--;
+ 		PROCLOCK_PRINT("LockCheckConflicts: auto TX conflict with parent TX", proclock);
+ 		ereport(ERROR,
+ 			(errmsg("lock %s on object %u/%u/%u/%u required by auto TX is conflict with parent TX",
+ 				lockMethodTable->lockModeNames[lockmode],
+ 				lock->tag.locktag_field1,
+ 				lock->tag.locktag_field2,
+ 				lock->tag.locktag_field3,
+ 				lock->tag.locktag_field4)));
+ 	}
+ 	/*check deadlock with upper autox*/
+ 	for (i = 0; i < MyProc->inAutoTXLevel - 1; i++)
+ 	{
+ 		if (lockMethodTable->conflictTab[lockmode] & proclock->holdMaskByAutoTX[i])
+ 		{
+ 			lock->nRequested--;
+ 			Assert(lock->requested[lockmode] > 0);
+ 			lock->requested[lockmode]--;
+ 			PROCLOCK_PRINT("LockCheckConflicts: auto TX conflict with parent AutoX", proclock);
+ 			ereport(ERROR,
+ 				(errmsg("lock %s on object %u/%u/%u/%u required by auto TX is conflict with parent AutoX",
+ 					lockMethodTable->lockModeNames[lockmode],
+ 					lock->tag.locktag_field1,
+ 					lock->tag.locktag_field2,
+ 					lock->tag.locktag_field3,
+ 					lock->tag.locktag_field4)));
+ 		}
+ 	}
+ }
+ 
*** a/src/backend/storage/lmgr/predicate.c
--- b/src/backend/storage/lmgr/predicate.c
***************
*** 199,204 ****
--- 199,205 ----
  #include "utils/rel.h"
  #include "utils/snapmgr.h"
  #include "utils/tqual.h"
+ #include "storage/proc.h"
  
  /* Uncomment the next line to test the graceful degradation code. */
  /* #define TEST_OLDSERXID */
***************
*** 502,507 **** SerializationNeededForRead(Relation relation, Snapshot snapshot)
--- 503,518 ----
  		return false;
  
  	/*
+ 	 * BEGIN<x00221760>
+ 	 * Don't acquire locks or conflict if it is an autonomous transaction. Autonomous
+ 	 * transaction always does simple work like create partition or create undo segement,
+ 	 * it should not faild because of serializable isolation.
+ 	 */
+ 	if (MyProc->inAutoTXLevel)
+ 		return false;
+ 	/* END */
+ 
+ 	/*
  	 * Check if we have just become "RO-safe". If we have, immediately release
  	 * all locks as they're not needed anymore. This also resets
  	 * MySerializableXact, so that subsequent calls to this function can exit
*** a/src/backend/storage/lmgr/proc.c
--- b/src/backend/storage/lmgr/proc.c
***************
*** 62,67 **** bool		log_lock_waits = false;
--- 62,68 ----
  /* Pointer to this process's PGPROC and PGXACT structs, if any */
  PGPROC	   *MyProc = NULL;
  PGXACT	   *MyPgXact = NULL;
+ PGAutonomousXACT *MyPgAutonomousXact = NULL;
  
  /*
   * This spinlock protects the freelist of recycled PGPROC structures.
***************
*** 112,117 **** ProcGlobalShmemSize(void)
--- 113,122 ----
  	size = add_size(size, mul_size(NUM_AUXILIARY_PROCS, sizeof(PGXACT)));
  	size = add_size(size, mul_size(max_prepared_xacts, sizeof(PGXACT)));
  
+ 	size = add_size(size, mul_size(MaxBackends * MAX_AUTOX_NESTING_LEVEL, sizeof(PGAutonomousXACT)));
+ 	size = add_size(size, mul_size(NUM_AUXILIARY_PROCS * MAX_AUTOX_NESTING_LEVEL, sizeof(PGAutonomousXACT)));
+ 	size = add_size(size, mul_size(max_prepared_xacts * MAX_AUTOX_NESTING_LEVEL, sizeof(PGAutonomousXACT)));
+ 
  	return size;
  }
  
***************
*** 162,167 **** InitProcGlobal(void)
--- 167,175 ----
  	bool		found;
  	uint32		TotalProcs = MaxBackends + NUM_AUXILIARY_PROCS + max_prepared_xacts;
  
+ 	PGAutonomousXACT	   *pgautonomousxacts;
+ 
+ 
  	/* Create the ProcGlobal shared structure */
  	ProcGlobal = (PROC_HDR *)
  		ShmemInitStruct("Proc Header", sizeof(PROC_HDR), &found);
***************
*** 210,215 **** InitProcGlobal(void)
--- 218,229 ----
  	MemSet(pgxacts, 0, TotalProcs * sizeof(PGXACT));
  	ProcGlobal->allPgXact = pgxacts;
  
+ 	pgautonomousxacts = (PGAutonomousXACT *) ShmemAlloc(TotalProcs * MAX_AUTOX_NESTING_LEVEL * sizeof(PGAutonomousXACT));
+ 	/*lint -e506 -e681  */
+ 	MemSet(pgautonomousxacts, 0, TotalProcs * MAX_AUTOX_NESTING_LEVEL * sizeof(PGAutonomousXACT));
+ 	/*lint +e506 +e681  */
+     ProcGlobal->allPgAutonomousXact = pgautonomousxacts;
+ 
  	for (i = 0; i < TotalProcs; i++)
  	{
  		/* Common initialization for all PGPROCs, regardless of type. */
***************
*** 279,284 **** InitProcess(void)
--- 293,299 ----
  {
  	/* use volatile pointer to prevent code rearrangement */
  	volatile PROC_HDR *procglobal = ProcGlobal;
+ 	int pgautotxno = 0;
  
  	/*
  	 * ProcGlobal should be set up already (if we are a backend, we inherit
***************
*** 317,322 **** InitProcess(void)
--- 332,340 ----
  
  	if (MyProc != NULL)
  	{
+ 		MyProc->inAutoTXLevel = 0;
+ 
+ 
  		if (IsAnyAutoVacuumProcess())
  			procglobal->autovacFreeProcs = (PGPROC *) MyProc->links.next;
  		else if (IsBackgroundWorker)
***************
*** 340,345 **** InitProcess(void)
--- 358,368 ----
  	}
  	MyPgXact = &ProcGlobal->allPgXact[MyProc->pgprocno];
  
+ 	pgautotxno = MyProc->pgprocno*MAX_AUTOX_NESTING_LEVEL;
+ 	MyPgAutonomousXact = &ProcGlobal->allPgAutonomousXact[pgautotxno];
+ 	MemSet(MyPgAutonomousXact, 0, MAX_AUTOX_NESTING_LEVEL*sizeof(PGAutonomousXACT));
+ 
+ 
  	/*
  	 * Now that we have a PGPROC, mark ourselves as an active postmaster
  	 * child; this is so that the postmaster can detect it if we exit without
***************
*** 390,395 **** InitProcess(void)
--- 413,419 ----
  	/* Initialize fields for sync rep */
  	MyProc->waitLSN = 0;
  	MyProc->syncRepState = SYNC_REP_NOT_WAITING;
+ 
  	SHMQueueElemInit(&(MyProc->syncRepLinks));
  
  	/*
***************
*** 464,469 **** InitAuxiliaryProcess(void)
--- 488,494 ----
  {
  	PGPROC	   *auxproc;
  	int			proctype;
+ 	int			pgautoxno;
  
  	/*
  	 * ProcGlobal should be set up already (if we are a backend, we inherit
***************
*** 515,520 **** InitAuxiliaryProcess(void)
--- 540,549 ----
  	MyProc = auxproc;
  	MyPgXact = &ProcGlobal->allPgXact[auxproc->pgprocno];
  
+ 	pgautoxno = auxproc->pgprocno * MAX_AUTOX_NESTING_LEVEL;
+ 	MyPgAutonomousXact = &ProcGlobal->allPgAutonomousXact[pgautoxno];
+ 
+ 
  	SpinLockRelease(ProcStructLock);
  
  	/*
***************
*** 1669,1671 **** ProcSendSignal(int pid)
--- 1698,1708 ----
  	if (proc != NULL)
  		PGSemaphoreUnlock(&proc->sem);
  }
+ 
+ PGAutonomousXACT *GetCurrentPGAutonomousXACT(void)
+ {
+ 	Assert(MyProc->inAutoTXLevel);
+ 
+ 	return &MyPgAutonomousXact[MyProc->inAutoTXLevel - 1];
+ }
+ 
*** a/src/backend/tcop/utility.c
--- b/src/backend/tcop/utility.c
***************
*** 414,419 **** standard_ProcessUtility(Node *parsetree,
--- 414,424 ----
  						UserAbortTransactionBlock();
  						break;
  
+ 					case TRANS_STMT_AUTONOMOUS:
+ 						RequireTransactionChain(isTopLevel, "AUTONOMOUS TRANSACTION");
+ 						DefineAutonomousTransaction();
+ 						break;
+ 
  					case TRANS_STMT_SAVEPOINT:
  						{
  							ListCell   *cell;
***************
*** 1751,1756 **** CreateCommandTag(Node *parsetree)
--- 1756,1765 ----
  						tag = "ROLLBACK PREPARED";
  						break;
  
+ 					case TRANS_STMT_AUTONOMOUS:
+ 						tag = "START AUTONOMOUS TRANSACTION";
+ 						break;
+ 
  					default:
  						tag = "???";
  						break;
*** a/src/backend/utils/cache/catcache.c
--- b/src/backend/utils/cache/catcache.c
***************
*** 1326,1331 **** ReleaseCatCache(HeapTuple tuple)
--- 1326,1399 ----
  		CatCacheRemoveCTup(ct->my_cache, ct);
  }
  
+ /*if it is a autonomous transaction, it will not use syscache*/
+ HeapTuple
+ SearchSystableForAutoX(CatCache *cache,
+ 			   Datum v1,
+ 			   Datum v2,
+ 			   Datum v3,
+ 			   Datum v4)
+ {
+ 	ScanKeyData cur_skey[CATCACHE_MAXKEYS];
+ 	Relation	relation;
+ 	SysScanDesc scandesc;
+ 	HeapTuple	ntp = NULL;
+ 	HeapTuple	dtp = NULL;
+ 
+ 	/*
+ 	 * one-time startup overhead for each cache
+ 	 */
+ 	if (cache->cc_tupdesc == NULL)
+ 		CatalogCacheInitializeCache(cache);
+ 
+ #ifdef CATCACHE_STATS
+ 	cache->cc_searches++;
+ #endif
+ 
+ 	/*
+ 	 * initialize the search key information
+ 	 */
+ 	memcpy(cur_skey, cache->cc_skey, sizeof(cur_skey));
+ 	cur_skey[0].sk_argument = v1;
+ 	cur_skey[1].sk_argument = v2;
+ 	cur_skey[2].sk_argument = v3;
+ 	cur_skey[3].sk_argument = v4;
+ 
+ 	relation = heap_open(cache->cc_reloid, AccessShareLock);
+ 	scandesc = systable_beginscan(relation,
+ 								  cache->cc_indexoid,
+ 								  IndexScanOK(cache, cur_skey),
+ 								  NULL,
+ 								  cache->cc_nkeys,
+ 								  cur_skey);
+ 
+ 	ntp = systable_getnext(scandesc);
+ 	if (NULL != ntp)
+ 	{
+ 		dtp = (HeapTupleData *) palloc(sizeof(HeapTupleData));
+ 
+ 		heap_copytuple_with_tuple(ntp, dtp);
+ 	}
+ 
+ 	systable_endscan(scandesc);
+ 
+ 	heap_close(relation, AccessShareLock);
+ 
+ 	return dtp;
+ }
+ 
+ void
+ ReleaseHeapTupleforAutoX(HeapTuple tuple)
+ {
+ 	if(NULL != tuple)
+ 	{
+ 		if(NULL != tuple->t_data)
+ 		{
+ 			pfree(tuple->t_data);
+ 		}
+ 		pfree(tuple);
+ 	}
+ }
  
  /*
   *	GetCatCacheHashValue
*** a/src/backend/utils/cache/inval.c
--- b/src/backend/utils/cache/inval.c
***************
*** 778,789 **** MakeSharedInvalidMessagesArray(const SharedInvalidationMessage *msgs, int n)
   */
  int
  xactGetCommittedInvalidationMessages(SharedInvalidationMessage **msgs,
! 									 bool *RelcacheInitFileInval)
  {
  	MemoryContext oldcontext;
  
  	/* Must be at top of stack */
! 	Assert(transInvalInfo != NULL && transInvalInfo->parent == NULL);
  
  	/*
  	 * Relcache init file invalidation requires processing both before and
--- 778,791 ----
   */
  int
  xactGetCommittedInvalidationMessages(SharedInvalidationMessage **msgs,
! 									 bool *RelcacheInitFileInval,
! 									 bool isAutoXact)
  {
  	MemoryContext oldcontext;
  
  	/* Must be at top of stack */
! 	if (!isAutoXact)
! 		Assert(transInvalInfo != NULL && transInvalInfo->parent == NULL);
  
  	/*
  	 * Relcache init file invalidation requires processing both before and
***************
*** 982,987 **** AtEOSubXact_Inval(bool isCommit)
--- 984,1067 ----
  }
  
  /*
+  * AtEOAutoXact_Inval
+  *		Process queued-up invalidation messages at end of autonomous transaction.
+  *
+  * If isCommit, we must send out the messages in our PriorCmdInvalidMsgs list
+  * to the shared invalidation message queue.  Note that these will be read
+  * not only by other backends, but also by our own backend at the next
+  * transaction start (via AcceptInvalidationMessages).	This means that
+  * we can skip immediate local processing of anything that's still in
+  * CurrentCmdInvalidMsgs, and just send that list out too.
+  *
+  * If not isCommit, we are aborting, and must locally process the messages
+  * in PriorCmdInvalidMsgs.	No messages need be sent to other backends,
+  * since they'll not have seen our changed tuples anyway.  We can forget
+  * about CurrentCmdInvalidMsgs too, since those changes haven't touched
+  * the caches yet.
+  *
+  * In any case, pop the transaction stack.	We need not physically free memory
+  * here, since CurTransactionContext is about to be emptied anyway
+  * (if aborting).  Beware of the possibility of aborting the same nesting
+  * level twice, though.
+  */
+ void
+ AtEOAutoXact_Inval(bool isCommit)
+ {
+ 	int			my_level = GetCurrentTransactionNestLevel();
+ 	TransInvalidationInfo *myInfo = transInvalInfo;
+ 
+ 	if (isCommit)
+ 	{
+ 		/* Must be at non-top of stack */
+ 		Assert(myInfo != NULL && myInfo->parent != NULL);
+ 		Assert(myInfo->my_level == my_level);
+ 
+ 		/*
+ 		 * Relcache init file invalidation requires processing both before and
+ 		 * after we send the SI messages.  However, we need not do anything
+ 		 * unless we committed.
+ 		 */
+ 		if (myInfo->RelcacheInitFileInval)
+ 			RelationCacheInitFilePreInvalidate();
+ 
+ 		AppendInvalidationMessages(&myInfo->PriorCmdInvalidMsgs,
+ 								   &myInfo->CurrentCmdInvalidMsgs);
+ 
+ 		ProcessInvalidationMessagesMulti(&myInfo->PriorCmdInvalidMsgs,
+ 										 SendSharedInvalidMessages);
+ 
+ 
+ 		if (myInfo->RelcacheInitFileInval)
+ 			RelationCacheInitFilePostInvalidate();
+ 
+ 		/* Pop the transaction state stack */
+ 		transInvalInfo = myInfo->parent;
+ 
+ 		/* Need not free anything else explicitly */
+ 		pfree(myInfo);
+ 	}
+ 	else if (myInfo != NULL && myInfo->my_level == my_level)
+ 	{
+ 		/* Must be at non-top of stack */
+ 		Assert(myInfo->parent != NULL);
+ 
+ 		ProcessInvalidationMessages(&myInfo->PriorCmdInvalidMsgs,
+ 									LocalExecuteInvalidationMessage);
+ 
+ 		/* Pop the transaction state stack */
+ 		transInvalInfo = myInfo->parent;
+ 
+ 		/* Need not free anything else explicitly */
+ 		pfree(myInfo);
+ 	}
+ 
+ 	/* when auto transaction end, unset SharedInvalidMessagesArray  and numSharedInvalidMessagesArray */
+ 	SharedInvalidMessagesArray = NULL;
+ 	numSharedInvalidMessagesArray = 0;
+ }
+ 
+ /*
   * CommandEndInvalidationMessages
   *		Process queued-up invalidation messages at end of one command
   *		in a transaction.
*** a/src/backend/utils/cache/syscache.c
--- b/src/backend/utils/cache/syscache.c
***************
*** 66,71 ****
--- 66,72 ----
  #include "utils/rel.h"
  #include "utils/catcache.h"
  #include "utils/syscache.h"
+ #include "storage/proc.h"
  
  
  /*---------------------------------------------------------------------------
***************
*** 906,911 **** SearchSysCache(int cacheId,
--- 907,917 ----
  		!PointerIsValid(SysCache[cacheId]))
  		elog(ERROR, "invalid cache ID: %d", cacheId);
  
+ 	if (MyProc->inAutoTXLevel)
+ 	{
+ 		return SearchSystableForAutoX(SysCache[cacheId], key1, key2, key3, key4);
+ 	}
+ 
  	return SearchCatCache(SysCache[cacheId], key1, key2, key3, key4);
  }
  
***************
*** 916,921 **** SearchSysCache(int cacheId,
--- 922,934 ----
  void
  ReleaseSysCache(HeapTuple tuple)
  {
+ 
+ 	if (MyProc->inAutoTXLevel)
+ 	{
+ 		ReleaseHeapTupleforAutoX(tuple);
+ 		return;
+ 	}
+ 
  	ReleaseCatCache(tuple);
  }
  
